]> git.pld-linux.org Git - packages/rpm-pld-macros.git/blame - rpm.macros
- 1.452: %_kernel_vermagic: a macro to be added @release that use `uname -r` as source
[packages/rpm-pld-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
36eccf0d
ER
11%__rm /bin/rm --interactive=never
12
33040789 13# Build system path macros.
14#
bddadece
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
f93109a0 17%__autopoint autopoint --force
18
83094b62 19%__gettextize { \
8a995cff 20 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 21 gettextize --copy --force --no-changelog; \
97589b6e 22 else \
3241033b 23 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
24 fi; \
25 if [ ! -f po/Makevars ]; then \
3241033b 26 cp -f po/Makevars{.template,}; \
8a995cff 27 fi; \
8a995cff 28}
f93109a0 29
30%__glib_gettextize glib-gettextize --copy --force
31%__gnome_doc_common gnome-doc-common --copy
fb59e475 32%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 33%__gtkdocize gtkdocize --copy
34%__intltoolize intltoolize --copy --force
35%__libtoolize libtoolize --copy --force
33040789 36
384e1b2b 37# Path to top of build area.
f5f7156a 38%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 39
81e450f7
ER
40# The number of cvs changelog entries kept when building package.
41%_buildchangelogtruncate 20
42
6a5eda77 43%dependencytracking %{nil}
3241033b 44
e5da9169
ER
45# Relations between package names that cause dependency loops
46# with legacy packages that cannot be fixed. Relations are
47# specified as
48# p>q
49# where package p has a Requires: on something that package q Provides:
50#
51# XXX Note: that there cannot be any whitespace within the string "p>q",
52# and that both p and q are package names (i.e. no version/release).
53%_dependency_whiteout %{nil}
54
7bf0526c
AM
55%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
810fa5c4 58
59#-----------------------------------------------------------------
60#
61# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
62# BuildRequires: awk
63# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 64#
65# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 66# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
67# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
68# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 69#
70# Regular expressions are supported, but to avoid some character be treated
71# as regular expression it must be escaped twice.
72
73%filter_out \
7b6f1112 74 for (i = 1; i in I; i++) { A=0; \
810fa5c4 75 for (f in F) { \
76 if (I[i] ~ "^" F[f] "$") A=1; \
77 }; \
78 if (!A) printf(I[i] FS); \
79 }
80
81%rpmcflags %(awk 'BEGIN {
82 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 83 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 84 %{filter_out}
85}')
86
87%rpmcxxflags %(awk 'BEGIN {
09a90176 88 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 90 %{filter_out}
91}')
92
93%rpmldflags %(awk 'BEGIN {
c05a0741 94 split("%{?optldflags}",I);
810fa5c4 95 split("%{?filterout_ld}",F)
96 %{filter_out}
97}')
98
25f52d1a 99# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100# but, don't use it, better use gcc as linker
101%ld_rpmldflags %(awk 'BEGIN {
102 split("%{rpmldflags}",F);
103 for (f in F) {
104 s = F[f];
105 if (s ~ /^-Wl,/) {
106 s = substr(s,5);
107 gsub(/,/," ",s);
108 };
109 printf(s FS);
110 };
111}')
112
9c404149 113#-----------------------------------------------------------------
9f4ce098 114%configure2_13 { \
9c404149
AM
115 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 118 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 119 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 120 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
8ec1a12b 121 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
8983c4c4
AM
122 %{?__cc:CC="%{__cc}" ; export CC ; } \
123 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 124 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 125 --host=%{_target_platform} \
9c404149
AM
126 --prefix=%{_prefix} \
127 --exec-prefix=%{_exec_prefix} \
128 --bindir=%{_bindir} \
129 --sbindir=%{_sbindir} \
130 --sysconfdir=%{_sysconfdir} \
131 --datadir=%{_datadir} \
132 --includedir=%{_includedir} \
133 --libdir=%{_libdir} \
134 --libexecdir=%{_libexecdir} \
135 --localstatedir=%{_localstatedir} \
136 --sharedstatedir=%{_sharedstatedir} \
137 --mandir=%{_mandir} \
138 --infodir=%{_infodir} \
b6c5da52 139 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 140 %{dependencytracking} \
9c404149
AM
141}
142
89f4ca1f
ER
143# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144%__cmake /usr/bin/cmake
39b9534b
ER
145%cmake { \
146CC="%{__cc}" \
147CXX="%{__cxx}" \
148CFLAGS="%{rpmcflags}" \
149CXXFLAGS="%{rpmcxxflags}" \
89f4ca1f
ER
150%{__cmake} \
151}
152
153# override __scons to add -j4 in your ~/.rpmmacros for parallel make
154%__scons /usr/bin/scons
155%scons { \
156%{__scons} \
5c76736d
ER
157 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158 CFLAGS="${CFLAGS:-%rpmcflags}" \
159 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160 FFLAGS="${FFLAGS:-%rpmcflags}" \
161 CPPFLAGS="${CPPFLAGS:-}" \
162 %{?__cc:CC="%{__cc}"} \
163 %{?__cxx:CXX="%{__cxx}"} \
164 libsuffix=%{_lib} \
165 prefix=%{_prefix} \
39b9534b
ER
166}
167
6339d32d 168# waf. see waf.spec
89f4ca1f 169# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
170%__waf /usr/bin/waf
171%waf { \
6339d32d
ER
172CC="%{__cc}" \
173CXX="%{__cxx}" \
9e244007 174CPP="%{__cpp}" \
6339d32d
ER
175CFLAGS="%{rpmcflags}" \
176CXXFLAGS="%{rpmcxxflags}" \
177%{__waf} \
6339d32d
ER
178}
179
4a6b0d54 180#----------------------------------------------------------------
9bacbb5b 181#%configure_cache 0
fe6c4bdd 182%configure_cache_file %{buildroot}.configure.cache
73f832b3 183
57f4166d 184%configure {./configure \
4a6b0d54
AF
185 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 187 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 188 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 189 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
a2bd5992 190 CPPFLAGS="${CPPFLAGS:-}" \
8983c4c4
AM
191 %{?__cc:CC="%{__cc}"} \
192 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 193 --host=%{_target_platform} \
4a6b0d54
AF
194 --build=%{_target_platform} \
195 --prefix=%{_prefix} \
196 --exec-prefix=%{_exec_prefix} \
197 --bindir=%{_bindir} \
198 --sbindir=%{_sbindir} \
199 --sysconfdir=%{_sysconfdir} \
200 --datadir=%{_datadir} \
201 --includedir=%{_includedir} \
202 --libdir=%{_libdir} \
203 --libexecdir=%{_libexecdir} \
204 --localstatedir=%{_localstatedir} \
205 --sharedstatedir=%{_sharedstatedir} \
206 --mandir=%{_mandir} \
207 --infodir=%{_infodir} \
b6c5da52 208 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 209 %{dependencytracking} \
9bacbb5b 210 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
211}
212
b3b1397b
ER
213# overload to insert debuginfo package
214%prep \
215%if 0%{?_enable_debug_packages}\
216%{debug_package}\
217%endif\
218%%prep\
219%{nil}
220
9c404149 221# Location of autoconf macros
7f0f4a79 222%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 223
e2804f99 224# Location of omf files
7f0f4a79 225%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 226
e987a186 227# Location of pkgconfig files
9a4e877a 228%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
229# noarch pkgconfig files
230%_npkgconfigdir /usr/share/pkgconfig
e987a186 231
486b0b5f 232# Location of desktop files
233%_desktopdir /usr/share/applications
86dff2d0 234%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 235
481463e9 236# Location of pixmaps for applnk/desktop files
e1f0a822 237%_pixmapsdir /usr/share/pixmaps
9c404149 238
481463e9 239# Location of themable icons for applnk/desktop files
b36c8e2a 240%_iconsdir /usr/share/icons
241
e987a186
JB
242# Location of fonts directories
243%_fontsdir /usr/share/fonts
244
b3282f3f 245# Location of Gtk and associated libraries documentation
fe6c4bdd 246%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 247
fc4d7771 248# Location of KDE documentation
fe6c4bdd 249%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 250
5869828c 251# unsermake script
252%__unsermake /usr/share/unsermake/unsermake
253
9c404149
AM
254# Current date
255%date %(LC_ALL="C" date +"%a %b %d %Y")
256
9c404149
AM
257# Example files, programs, scripts...
258%_examplesdir /usr/src/examples
259
c8f7e820 260# Alternative kernel type/version
261729d9 261%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 262
8377d27d 263# The directory holding Linux kernel sources
261729d9 264%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 265
9c404149 266# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 267%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 268
8f74418b 269# Requires name = version-release
d514eecd 270%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
8bf3719d 271
f5f7156a
ER
272%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
273%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
274%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
275%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
276%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
277%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 278
d514eecd
ER
279# XXX: why epoch 0 is stripped?
280%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
281%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
01a9f990 282
c94807f3 283%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 284
285# kernel version-release handling
95125403
ER
286%__kernel_ver %{expand:%%global __kernel_ver %( \\
287 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
288 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
289 echo ${Z:-ERROR}; \\
1a7d3518 290)}%__kernel_ver
95125403 291
c94807f3
ER
292%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
293%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
294%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
295%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 296
6262f001
ER
297# `uname -r` to be used in @release field
298%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
299
e00dd7f6 300# sgml macros
3241033b
ER
301%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
302%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
303%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
304%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
305%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
306%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 307%docbook_sgmlcat_fix() { for l in \
308'' \
309' -- default decl --' \
310'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
311' -- hacks for opensp --' \
312'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
313'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
314'' \
315; do echo $l; done >> %1 \
316}
317
eea64748
ER
318# vim - "
319
4f044018
ER
320# minimum file size needed for compressed documents.
321# just smaller files than this get larger when compressed.
a88ae20f
ER
322# some stats:
323# - 0 byte file compressed was 25 bytes .gz
324# - 39 byte file was compressed as 57
325# - with test/test.spec@man 158 byte file was compressed also 158
326%_min_compress_bytes 159
4f044018 327
9c404149
AM
328#-----------------------------------------------------------------
329# find and gzip all files in %{_mandir} and %{infodir}
330#
331# Requires: xargs, find
332#
333#%no_install_post_compress_docs 1
334%__spec_install_post_compress_docs { \
53d5af13 335%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 336 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 337 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 338 echo "Compress man pages: $i"; \
4f044018
ER
339 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
340 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
341 find $RPM_BUILD_ROOT$i -type l | while read a; do \
342 m=$(readlink $a); \
343 rm -f $a; \
344 echo .so ${m##*/} > $a; \
345 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
346 done; \
4f044018 347 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
348 fi; \
349 done; \
728ad671
JB
350 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
351 echo "Compress info pages: %{_infodir}"; \
352 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
353 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
354 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 355 fi; \
53d5af13 356}; __spec_install_post_compress_docs } }
9c404149
AM
357
358#-----------------------------------------------------------------
359# Strip executable binaries and shared object files
360#
361# Requires: find, awk, strip, cut, xargs
362#
a2ad2754
JB
363# Special macros which affect this process:
364#%no_install_post_strip 1 # disable stripping at all
365#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
366#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
367#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
368#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
369#
9c404149 370%__spec_install_post_strip {%{!?debug: \
53d5af13 371%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 372if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
373 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
374 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
375 if [ "$modulelist" ]; then \
376 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 377 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
378 echo "$modulelist" | xargs -l512 chmod u+w; \
379 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
380 echo "DONE"; \
381 fi; \
eea64748 382 fi; \
0ac49134 383 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
384 if [ -n "$filelist" ]; then \
385 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
386 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
387 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 388 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 389 if [ -n "$elfexelist" ]; then \
4d5370ac 390 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
391 chmod u+w $elfexelist; \
392 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
393 echo "DONE"; \
394 fi; \
395 if [ -n "$elfsharedlist" ]; then \
4d5370ac 396 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
397 chmod u+w $elfsharedlist; \
398 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
399 echo "DONE"; \
400 fi; \
401 if [ -n "$archiveslist" ]; then \
4d5370ac 402 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
403 chmod u+w $archiveslist; \
404 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
405 echo "DONE"; \
406 fi; \
98a06bad 407 fi; \
0ac49134
ER
408 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
409 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
410 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 411 if [ -n "$filelist_all" ]; then \
4d5370ac 412 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 413 chmod u+w $filelist_all; \
f89ccb5f 414 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 415 echo "DONE"; \
9c404149 416 fi; \
f89ccb5f 417 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 418 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 419 chmod u+w $filelist_unneeded; \
f89ccb5f 420 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 421 echo "DONE"; \
8f74418b 422 fi; \
f89ccb5f 423 if [ -n "$filelist_debug" ]; then \
4d5370ac 424 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 425 chmod u+w $filelist_debug; \
f89ccb5f 426 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 427 echo "DONE"; \
9f0d4f36 428 fi; \
53d5af13 429fi; }; __spec_install_post_strip } } }
3241033b 430
fc5d7e20 431#-----------------------------------------------------------------
432# remove all RPATH from executable binaries and shared object files
433#
434# Requires: find, awk, cut, xargs, chrpath, uname
435#
a2ad2754
JB
436# Special macros which affect this process
437#%no_install_post_chrpath 1 # disable chrpath at all
438#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
439#
fc5d7e20 440%__spec_install_post_chrpath {%{!?debug: \
53d5af13 441%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 442if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 443 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 444 if [ -n "$files" ]; then \
d5517264 445 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 446 fi; \
98a06bad 447 if [ -n "$objs" ]; then \
4d5370ac 448 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
449 echo "$objs" | \
450 while read file; do \
451 rpath= ; \
452 chmod u+w "$file"; \
453 for dir in `chrpath -l "$file" | \
454 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
d3863312 455 dir=`%{__python} -c 'import sys, os; print os.path.normpath(sys.argv[1]);' $dir`
98a06bad
ER
456 case $dir in \
457 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
458 echo "remove-rpath: $dir in $file"; \
459 ;; \
460 * ) \
461 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
462 else rpath="$rpath:$dir" ; fi ; \
463 ;; \
464 esac ; \
465 done ; \
466 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
467 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
468 done; \
469 fi; \
53d5af13 470fi; }; __spec_install_post_chrpath } } }
3241033b 471
d72c185f 472#-----------------------------------------------------------------
ccb8ae8d 473# Find and gzip all kernel modules
474#
475# Requires: find
476#
fe6c4bdd 477#%no_install_post_compress_modules 1
ccb8ae8d 478%__spec_install_post_compress_modules { \
53d5af13 479%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 480 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 481 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
482 if [ "$q" ]; then \
483 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
484 echo "$q" | xargs -r %{__gzip} -9nf; \
485 echo "DONE"; \
486 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
487 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
488 fi; \
3241033b 489 fi; \
53d5af13 490}; __spec_install_post_compress_modules } }
9c404149 491
ef64802f
ER
492# Remove common Perl files we don't package
493%__spec_install_post_perl_clean {\
494%{!?no_install_post_perl_clean: \
495%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
496} }
497
83094b62 498#-----------------------------------------------------------------
0e4cb4dd 499# Update GConf2 schemas
83094b62 500#
501# Requires: GConf2
502#
46885239 503%gconf_schema_install() \
3241033b 504 umask 022; \
f27cf2fd
ER
505 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
506%{nil}
46885239 507
508%gconf_schema_uninstall() \
f93109a0 509if [ $1 = 0 ]; then \
3241033b
ER
510 umask 022; \
511 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 512fi; \
f93109a0 513%{nil}
514
515#-----------------------------------------------------------------
516# Update desktop MIME database
c0a4caa0 517# requires: desktop-file-utils
c3bcd10e 518%update_desktop_database() {{ \
f93109a0 519 umask 022; \
fb59e475 520 /usr/bin/update-desktop-database -q; \
1c744c87 521}}%{nil}
f93109a0 522
c3bcd10e
ER
523%update_desktop_database_post %update_desktop_database
524
525%update_desktop_database_postun() {{ \
f27cf2fd 526if [ "$1" = "0" ]; then \
c3bcd10e 527 %update_desktop_database; \
f27cf2fd 528fi; \
1c744c87 529}}%{nil}
f93109a0 530
fb59e475 531#-----------------------------------------------------------------
532# Update shared MIME info database
533# requires: shared-mime-info
534#
c3bcd10e 535%update_mime_database() {{ \
fb59e475 536 umask 022; \
537 /usr/bin/update-mime-database %{_datadir}/mime; \
1c744c87 538}}%{nil}
fb59e475 539
540#-----------------------------------------------------------------
541# Update icon cache
542# requires: gtk+
543#
c3bcd10e 544%update_icon_cache() {{ \
fb59e475 545 umask 022; \
072f4b80 546 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
1c744c87 547}}%{nil}
fb59e475 548
f93109a0 549#-----------------------------------------------------------------
550# Update scrollkeeper database
551# requires: scrollkeeper
552#
553%scrollkeeper_update_post() \
f93109a0 554 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 555%{nil}
f93109a0 556
557%scrollkeeper_update_postun() \
f27cf2fd 558if [ "$1" = "0" ]; then \
f93109a0 559 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 560fi; \
f93109a0 561%{nil}
562
9c404149
AM
563#-----------------------------------------------------------------
564# post %install sequence:
565# - autodeps exceptions
566# - compress all man and info pages,
567# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 568# - compress kernel modules if any
9c404149
AM
569
570###################################################################
571# Requires/Provides automation
572# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
338726a6 573#
2892b5df
JB
574%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
575%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
576%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
577%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
578%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 579
338726a6
JB
580#%_noautocompressdoc %{nil}
581#
8f74418b
MM
582%_missing_doc_files_terminate_build 1%{nil}
583%_unpackaged_files_terminate_build %{nil}
8781dc74 584# (X)emacs support
d77dcb61 585%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
586%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
587%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 588
02b58f60
JK
589%__php_provides %{nil}
590%__php_requires %{nil}
591%__perl_provides %{nil}
592%__perl_requires %{nil}
fa3497cd 593%__mono_provides %{nil}
594%__mono_requires %{nil}
25043cd4
AF
595
596# Perl specific macro definitions.
c94807f3
ER
597%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
598%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
599%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
600%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
601%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
602%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 603
45c00b39 604# Ruby
c94807f3
ER
605%__ruby /usr/bin/ruby
606%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
607%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
608%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
609%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
610%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
611%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
612%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
613%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
614%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
615%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 616
7ccf7643 617%php_pear_dir /usr/share/pear
c94807f3
ER
618%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
619%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
620%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 621
0c5d1b9b 622# extract php/zend api versions
c94807f3
ER
623%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
624%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
625%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
626%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
627%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
628%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
629%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
630
631# helper macro
f952c0f3 632%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
633
634# macros for public use
635# for php extensions (php-pecl)
68b68193 636%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 637%{__php_api_requires zend_module_api} \
f952c0f3
ER
638%{__php_api_requires -v %php_major_version debug php_debug} \
639%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 640
c1b2705c
ER
641# for zend extensions
642%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 643%{__php_api_requires zend_extension_api} \
f952c0f3
ER
644%{__php_api_requires -v %php_major_version debug php_debug} \
645%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 646
934c685f
ER
647# for php pdo modules (php-pecl-PDO_*)
648%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
649
6c3b8203
ER
650# for using PHP post scripts. for PHP >= 5.0
651%php_webserver_restart \
652[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 653[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
654if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
655 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
656 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
657 %service -q php-fcgi restart \
658 fi \
659fi \
6c3b8203
ER
660%{nil}
661
662# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
663%php4_webserver_restart \
664[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 665[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
666if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
667 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
668 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
669 %service -q php-fcgi restart \
670 fi \
671fi \
6c3b8203
ER
672%{nil}
673
578e9248
AM
674
675# X.org helper macros
40c78bc0 676%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
578e9248 677#
c94807f3
ER
678%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
679%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
680%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
681%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
682%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248
AM
683
684%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
685%{__xorg_abi_requires extension xorg_xserver_extension_abi}
686%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
687%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
688%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
689%{__xorg_abi_requires font xorg_xserver_font_abi}
690%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
691%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
692
25043cd4
AF
693# Python specific macro definitions.
694# python main version
c94807f3 695%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
25043cd4
AF
696
697# directories
c94807f3 698%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
3241033b 699%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 700%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 701%py_incdir /usr/include/python%{py_ver}
7ccf7643 702%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 703%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 704%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
705
706# pure python modules compilation
3241033b 707%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 708
3241033b 709%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
710
711# Software written in Python language require Python with main version
e63cd81d 712%pyrequires_eq() Requires: %1
25043cd4 713
f12c2314
AF
714# Hardlink binary identical .pyc and .pyo files
715# (idea by glen <at> pld-linux <dot> org)
716%__spec_install_post_py_hardlink {\
53d5af13 717%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f12c2314 718[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
83f0d22e 719 b="${a%.pyc}.pyo"; \
f12c2314
AF
720 if cmp -s "$a" "$b"; then \
721 ln -f "$a" "$b"; \
722 fi; \
723done \
53d5af13 724}; __spec_install_post_py_hardlink } }
f12c2314 725
9227b3f9 726# remove python sources, so that check-files won't complain
f12c2314
AF
727# (idea by glen <at> pld-linux <dot> org)
728%py_postclean() \
0f82e280 729for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 730 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
731done \
732%{nil}
733
0fc5cff8 734# depmod macro
735%depmod() { \
f6148427 736umask 022; \
0fc5cff8 737if [ -e /boot/System.map-%1 ]; then \
3241033b 738 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 739else \
3241033b
ER
740 if [ -e /boot/System.map ]; then \
741 /sbin/depmod -a -F /boot/System.map %1; \
742 else \
743 /sbin/depmod -a %1; \
744 fi \
0fc5cff8 745fi; \
746}
747
2afc6e64 748# XMMS specific macros
c94807f3
ER
749%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
750%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
751%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
752%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
753%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
754%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
755%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
756%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
757%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
758%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
759
760%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 761
848c0d68 762# user/group checking macros
763#
764# Usage:
765# %userremove myuser
766#
767%userremove /usr/lib/rpm/user_group.sh user del
768%groupremove /usr/lib/rpm/user_group.sh group del
769#
770# Usage:
771# if %usertestrm myuser; then
772# /usr/sbin/userdel -r myuser
773# Note:
774# use these macros only if you need to call userdel/groupdel with
775# a non-standard option or take an extra action; otherwise use the
776# %userremove/%groupremove macros
777#
778%usertestrm /usr/lib/rpm/user_group.sh user testrm
779%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
780# user group membership management macros
781#
782# Usage:
783# %addusertogroup myuser agroup
784#
785%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 786
787# banner support (useful in {pre,post}{,un} and triggers)
788#
789# Usage:
aa41c920 790# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 791# the banner text, the banner text
aa41c920
ER
792# the banner text, and following line
793#EOF
794# You can use any form of here-document, <<'EOF' <<-EOT will do.
795# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
796#
72fcfcb3 797# -a - append to the banner
a8b9562a 798# -e - send to stderr instead of stdout
628754cb 799# -n - no show banner (overrides -t)
800# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
801#
802# Tests:
803# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
804# rpm -E 'date | %banner -e banner' > m; sh -x m
805#
afb54f6c 806%banner(aent:) ( \
1b334fe4 807RPM_SCRIPTVERBOSITY=5 \
808[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
809if [ -x /usr/bin/banner.sh ]; then \
aa41c920 810 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 811else \
a8b9562a 812 CMD="cat%{-e: >&2}" \
1b334fe4 813fi \
276a7b45
ER
814eval $CMD %{?2:%2}%{?3: %3}) \
815%{nil}
628754cb 816
990bd03f 817# useradd/groupadd macros
4c73bc69 818# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
819#
820# Usage:
821# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
822# [-g initial_group] [-G group[,...]] login
823#
824# -u uid. REQUIRED
825# -g gid/group. REQUIRED
826# -s defaults to /bin/false
827# -d defaults to /usr/share/empty
828# -c No default
829# -r is accepted but ignored (it's always set)
6bd4c218 830# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
831# rpm specific flags
832# -P package name. defaults to %{name}
833#
90627280 834%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
835%{!-u:%{error:useradd: Required argument -u missing}} \
836%{!-g:%{error:useradd: Required argument -g missing}} \
837%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
838if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
839 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
840 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
841 exit 1 \
842 fi \
843else \
844 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
845 /usr/sbin/useradd \\\
b5a7d552 846 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
847 -u %{-u*} \\\
848 -r \\\
849 -d %{-d*}%{!-d:/usr/share/empty} \\\
850 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 851 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
852 -g %{-g*} \\\
853 %{-M} \\\
854 %{-G:-G %{-G*}} \\\
1aac682a 855 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 856 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
857fi;
858
90627280
ER
859# Usage:
860# %groupadd [-P package] [-g gid] group
861#
862# -g gid. REQUIRED
863#
864# Sample:
865# %groupadd -P %{name}-base -g %{gid} %{name}
866
867%groupadd(g:P:rfo) \
9ba02ba9
ER
868%{!-g:%{error:groupadd: Required argument -g missing}} \
869%{!?1:%{error:groupadd: Required parameter group missing}} \
90627280
ER
870if [ -n "`/usr/bin/getgid %{1}`" ]; then \
871 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
872 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
873 exit 1 \
874 fi \
875else \
876 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 877 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 878 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 879fi;
7cb77741 880
7c50f037 881# webapp macros
4c73bc69 882# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
883#
884# The config is installed/removed inside trigger, this means that you can any
885# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 886# updated. if you don't need the config for various reason for specific
35663282
ER
887# webserver, just remove the symlink from config directory using webapp
888# program. the trigger will not recreate the symlink on upgrades. In other
889# words the config is linked to webserver config directory on first install of
890# PACKAGE or WEBSERVER.
891#
7c50f037
ER
892# Add package's webserver config to webserver webapps dir.
893# Usage:
df979130 894# %webapp_register WEBSERVER WEBAPP
35663282
ER
895#
896%webapp_register() \
897%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
898if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
899 /usr/sbin/webapp register %1 %2\
900fi\
694a8f2e 901# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 902if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 903 %{expand:%service -q %%1 reload}\
35663282
ER
904fi\
905%{nil}
906
907# Remove package's config from webserver webapps dir.
35663282 908# Usage:
531c0efc
ER
909# %webapp_register [-f] WEBSERVER WEBAPP
910%webapp_unregister(f) \
35663282
ER
911%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
912# remove link if either of the packages are gone \
5d3a09a3 913if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 914 /usr/sbin/webapp unregister %1 %2\
16897aea 915 %{expand:%service -q %%1 reload}\
35663282
ER
916fi \
917%{nil}
918
462b26fa 919# service macro.
4c73bc69 920# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
921#
922# calls usual service restart on package %post, but skips the restart if
923# administrator has disabled automatic service restarts in either global
924# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
925#
462b26fa 926# Usage:
7377b5ca 927# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 928#
a0bbe604 929# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 930# -n NOOP mode, do not actually restart service
462b26fa 931#
7377b5ca
ER
932# Requirements:
933# BuildRequires: rpmbuild(macros) >= 1.268
934# Requires: rc-scripts
935# -n option:
936# BuildRequires: rpmbuild(macros) >= 1.450
937%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
938
939
f9aa75bf
ER
940# Java macros. based on jpackage macros.java
941#
942# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 943%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
944
945# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 946%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
947
948# Root directory for all Java VM/SDK/JRE's private things.
949%_jvmprivdir %{_libdir}/jvm-private
950
951# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 952%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
953
954# Root directory for all architecture independent parts of Java VM/SDK/JRE's
955%_jvmdatadir %{_datadir}/jvm
956
957# Root directory for all configurations parts of Java VM/SDK/JRE's
958%_jvmsysconfdir %{_sysconfdir}/jvm
959
960# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 961%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
962
963# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 964%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
965
966# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 967%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
968
969# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 970%_jnidir %{_libdir}/java
f9aa75bf 971
c94807f3 972%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 973
fe6c4bdd
ER
974%ant JAVA_HOME=%{java_home} ant
975%jar %{java_home}/bin/jar
c94807f3 976%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
977%javac %{java_home}/bin/javac
978%javadoc %{java_home}/bin/javadoc
6aedae62 979
fe6c4bdd 980%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
981
982%jpackage_script() \
3ca65b87
ER
983install -d $RPM_BUILD_ROOT%{_bindir}\
984cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
985#!/bin/sh\
986#\
987# %{name} script\
988# JPackage Project <http://www.jpackage.org/>\
989\
990# Source functions library\
991. %{_javadir}-utils/java-functions\
992\
993# Source system prefs\
3ca65b87 994if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 995 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
996fi\
997\
998# Source user prefs\
3ca65b87
ER
999if [ -f $HOME/.%{name}rc ]; then\
1000 . $HOME/.%{name}rc\
6aedae62
ER
1001fi\
1002\
1003# Configuration\
1004MAIN_CLASS=%1\
1005BASE_FLAGS=%2\
1006BASE_OPTIONS=%3\
3ca65b87 1007BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1008\
1009# Set parameters\
1010set_jvm\
3ca65b87
ER
1011set_classpath $BASE_JARS\
1012set_flags $BASE_FLAGS\
1013set_options $BASE_OPTIONS\
6aedae62
ER
1014\
1015# Let's start\
3ca65b87 1016run "$@"\
6aedae62
ER
1017EOF
1018
06f11871
ER
1019# jpackage 1.7
1020# Directory for maven depmaps
1021#
1022%_mavendepmapdir /etc/maven
1023%_mavendepmapfragdir /etc/maven/fragments
1024
1025#
1026# add_to_depmap adds an entry to the depmap. The arguments are:
1027#
1028# %1 the original groupid
1029# %2 the original artifact id
1030# %3 the version
1031# %4 the new groupid
1032# %5 the new artifactid
1033#
1034
1035%add_to_maven_depmap() \
1036install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1037cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1038<dependency>\
1039 <maven>\
1040 <groupId>%1</groupId>\
1041 <artifactId>%2</artifactId>\
1042 <version>%3</version>\
1043 </maven>\
1044 <jpp>\
1045 <groupId>%4</groupId>\
1046 <artifactId>%5</artifactId>\
1047 <version>%3</version>\
1048 </jpp>\
1049</dependency>\
1050\
1051EOF\
1052%{nil}
1053
1054#==============================================================================
1055#
1056# update_maven_depmap updates the main maven depmap
1057#
1058%update_maven_depmap() \
1059echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1060if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1061cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1062fi\
1063echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1064
1065
59d3ebe9 1066# PEAR install macros
4c73bc69 1067# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1068#
1069# Usage:
1070# %%pear_package_setup [-a #] [-n FMT]
1071#
59d3ebe9 1072# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1073# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1074# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
dfce8b19
ER
1075#
1076# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1077# destination hierarchy. you should copy the tree to buildroot after
1078# patching/reorganizing with %%pear_package_install.
1079#
1080# additionally BUILDROOT is stripped from files and files are converted to UNIX
1081# line endings.
1082#
1083# the pear install process output is recorded to install.log, you should put it
8763f51e 1084# to %%doc for later debug or just for information.
dfce8b19
ER
1085#
1086# additionally additional-packages.txt is produced if it was detected that the
1087# package has optional dependencies. the file format is suitable of displaying
1088# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1089# automatically added for this file.
59d3ebe9
ER
1090
1091
1092# records install.log and transforms PEAR names to PLD Linux rpm package names.
1093%__pear_install_log \
1094tee install.log \
1095# make post message of optional packages \
1096grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1097if [ -s optional-packages.txt ]; then \
1098 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1099else \
1100 rm -f optional-packages.txt \
1101fi \
1102%{nil}
1103
1104# command invoking pear cli
1105%__pear /usr/bin/pear
1106
67a089ff 1107%pear_install(a:n:zD) \
59d3ebe9
ER
1108%__pear \\\
1109 -c pearrc \\\
dfce8b19
ER
1110 -d doc_dir=/docs \\\
1111 -d php_dir=%{php_pear_dir} \\\
1112 -d bin_dir=%{_bindir} \\\
1113 -d data_dir=%{php_pear_dir}/data \\\
1114 -d test_dir=%{php_pear_dir}/tests \\\
1115 install \\\
59d3ebe9 1116 --packagingroot=%{builddir} \\\
dfce8b19
ER
1117 --offline \\\
1118 --nodeps \\\
1119 %{-f:--force} \\\
67a089ff
ER
1120 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1121%{nil}
1122
1123# The main macro.
1124# using this macro will append optional-packages.txt to the nocompressdoc list
1125# as it's displayed to user after package install. and adding additional gzip
1126# dep is just waste ;)
1127%pear_package_setup(a:n:zD) \
1128%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1129%define builddir %{_builddir}/%{srcdir} \
1130%setup -q -c -T %{-D:-D} -n %{srcdir} \
1131%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1132%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1133%pear_install \
59d3ebe9
ER
1134%{-z:cd ..} \
1135cat %{-z:$_N/}.install.log | %__pear_install_log \
1136\
dfce8b19 1137# undos sources \
2a80e4cf 1138find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1139%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1140%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1141%{nil}
1142
7bef60e8 1143# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1144# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1145%pear_package_install() \
1146cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1147find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1148# help the developer out a little: \
1149if [ -f _noautoreq ]; then \
1150 echo "AutoReqdep detected:" \
1151 echo "_noautoreq $(cat _noautoreq)" \
1152fi \
1153%{nil}
1154
0d5dd00c
ER
1155
1156# Register OpenLDAP schema.
4c73bc69 1157# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1158#
1159# Usage:
1160# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1161#
1162# -d specify dependant schemas, separated by comma
1163#
1164%openldap_schema_register(d:) \
1165for schema in %*; do \
1166 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1167 %{__sed} -i -e " \
1168 /^include.*local.schema/{ \
1169 iinclude\\t $schema\
1170 } \
1171 " /etc/openldap/slapd.conf \
1172 fi \
1173done \
1174# enable dependant schemas \
1175if [ "%{-d*}" ]; then \
1176 %{__sed} -i -e ' \
1177 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1178 s/^#// \
1179 }' /etc/openldap/slapd.conf \
1180fi \
1181%{nil}
1182
1183# Unregister OpenLDAP schema.
4c73bc69 1184# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1185#
1186# Usage:
1187# %%openldap_schema_unregister %{schemadir}/horde.schema
1188#
1189%openldap_schema_unregister() \
1190for schema in %*; do \
1191 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1192 %{__sed} -i -e " \
1193 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1194 # for symmetry it would be nice if we disable enabled schemas in post, \
1195 # but we really can not do that, it would break something else. \
1196 " /etc/openldap/slapd.conf \
1197 fi \
1198done \
1199%{nil}
1200
b0bc2936 1201%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1202
dcc6baf7 1203
1204# Build modules for kernels 2.6
1205# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1206#
1207# Usage:
aa559e46 1208# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1209#
1210# remember that proper Makefile is still required
1211# Options:
990bd03f 1212# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1213# without .ko extension, may be placed in subdirectory
aa559e46 1214# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1215# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1216# -c -- do not execute make clean
dcc6baf7 1217# <additional arguments> -- all additional arguments will be passed to
1218# make modules
1219#
1220# Additional patching supported via here document. Try:
1221# %build_kernel_modules -m module <<'EOF'
1222# your patch script here
1223# EOF
1224# Don't use it unless patching depends on config options.
1225
1226# Developer note: don't touch it unless you know how to handle '\'.
1227# - \ in script expands to nothing
1228# - \\\ in script expands to \
566398b4 1229# - \\\ inside definition expands to nothing
dcc6baf7 1230# - \\\\\\\ inside definition expands to \
1231# - in last line \ has to touch arguments so arguments passing
1232# in new lines (using \) will be supported
1233
5a81d83e 1234%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1235%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1236 \
1237%define Opts \\\\\\\
1238%if "%{_target_base_arch}" != "%{_arch}" \\\
1239 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1240 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1241 %else \\\
1242 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1243 %endif \\\
1244%else \\\
88608ef7 1245 CC="%{kgcc}" \\\
dcc6baf7 1246%endif \
88608ef7 1247%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1248 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1249 \
e364bc26 1250%{?-C:cd %{-C*}} \
dcc6baf7 1251compile() { \
ba9de9b2
ER
1252 local L="<" PATCH_SH; \
1253 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1254 set -e -x \
730239f9 1255 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1256 \
730239f9 1257for cfg in ${cfgs:-dist}; do \
dcc6baf7 1258 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1259 \
c546f6fb 1260 rm -rf o \
dcc6baf7 1261 install -d o/include/linux \
1262 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1263 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1264 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1265 \
1266 set +x \
1267 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1268 set -x \
1269 \
1270 %if %{with dist_kernel} \
1271 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1272 %{-p*} %{-P*} \\\
1273 %{MakeOpts} \
1274 %else \
1275 install -d o/include/config \
1276 touch o/include/config/MARKER \
1277 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1278 %endif \
1279 \
5a81d83e 1280 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1281 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1282 ${1+"$@"} \\\
5a81d83e 1283 M=$PWD %{MakeOpts}} \
f635907b 1284 \
dcc6baf7 1285 %{__make} -C %{_kernelsrcdir} modules \\\
1286 ${1+"$@"} \\\
1287 M=$PWD %{MakeOpts} \
1288 \
1289 for MODULE in {%{-m*},}; do \
1290 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1291 done \
1292done \
aa559e46 1293%{?-C:cd -} \
dcc6baf7 1294} \
1295compile %{*}\
1296%{nil}
1297
1298
1299# Install kernel modules built by %build_kernel_modules
1300# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1301#
1302# Usage:
1303# %install_kernel_modules -m <modules> -d <directory>
1304#
1305# Options:
990bd03f 1306# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1307# without .ko extension, may be placed in subdirectory
1308# -d <directory> (required) -- in what subdirectory modules should be
1309# installed (eg. misc, kernel/drivers/net)
1310# -s <suffix> -- suffix to use when installing modules, useful when module
1311# with same name exists in kernel already
1312# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1313# for defining aliases, only useful with -s
dcc6baf7 1314
1315%install_kernel_modules(m:d:s:n:) \
1316%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1317%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1318%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1319 \
1320%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1321%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1322 \
730239f9 1323local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1324 \
1325for MODULE in {%{-m*},}; do \
1326 [ -n "${MODULE}" ] || continue \
730239f9
ER
1327 for cfg in ${cfgs:-dist}; do \
1328 [ "$cfg" = smp ] && suf=smp || suf= \
1329 MNAME=${MODULE##*/} \
1330 install -D ${MODULE}-$cfg.ko \\\
1331 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1332 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1333 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1334 >> %{ModprobeD}$suf/%{-n*}.conf} \
1335 done \
dcc6baf7 1336done \
1337%{nil}
1338
fa65356c 1339# patchset macros
4c73bc69 1340# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1341#
1342# Usage:
1343# %patchset_source -f <seq(1) format> <start> [<end>]
1344# %patchset_patch <start> [<end>]
1345#
1346# If <end> is omited, it is assumed to be <start>.
1347#
1348# For example in preamble:
1349# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1350# and in %prep:
1351# %patchset_patch 33 44
1352
1353# generate SourceX urls from range START STOP
1354# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1355# The sources start from 10000
e91610db 1356%patchset_source(f:b:) %(
44f733ef 1357 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1358 start=$(expr $base + %1);
1359 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1360 # we need to call seq twice as it doesn't allow two formats
1361 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1362 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1363 paste %{tmpdir}/__ps{1,2};
1364 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1365) \
1366%{nil}
fa65356c
ER
1367
1368# apply sources from %patchset_source
1369# -p specify -pX for %patch line
1370# -b base offset: defaults to 10000
1371%patchset_patch(f:p:b:) %(
44f733ef 1372 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1373 start=$(expr $base + %1);
1374 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1375 echo ": patchset_patch %1%{?2: to %2}";
1376 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1377) \
1378%{nil}
fa65356c 1379
5730b44b 1380# browser plugins v2
4c73bc69 1381# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1382#
1383# Usage:
1384# %browser_plugins_add_browser <name> -p <plugindir>
1385#
1386# <name> (required) -- name of the browser. usually %{name}.
1387# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1388# -b -- default blacklists
1389# -a <arch> override arch
5730b44b
ER
1390#
1391# Example:
1392# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1393
1394%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1395%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1396%update_browser_plugins /usr/sbin/update-browser-plugins || :
1397
02ebf70f 1398%browser_plugins_add_browser(p:b:a:) \
9efd458e 1399 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1400 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1401 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1402 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1403 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1404 %{-b:cat >> $blacklist_file %{-b*}} \
1405%{nil}
1406
ad17b654
ER
1407# Helper for LUA.
1408# split string separated by space into quoted list
1409#
4c73bc69 1410# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1411#
1412# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1413%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1414
1415# adjust /etc/shells by adding and removing shells from there
4c73bc69 1416# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1417#
1418# Usage:
1419# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1420# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1421#
1422# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
7377b5ca
ER
1423#
1424# Requirements:
1425# BuildRequires: rpmbuild(macros) >= 1.429
ad17b654
ER
1426
1427%add_etc_shells(p) %{-p:<lua>}\
1428t = {}\
1429f = io.open("/etc/shells", "r")\
1430if f then\
1431 for l in f:lines() do t[l]=l; end\
1432 f:close()\
1433end\
1434for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1435 if not t[s] then\
b8c0bc18 1436 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1437 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1438 end\
1439end\
1440%{nil}
1441
1442%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1443%{-p:if arg[2] == 0 then}\
750e19f4
ER
1444 t = {}\
1445 f = io.open("/etc/shells", "r")\
1446 if f then\
1447 for l in f:lines() do t[l]=l; end\
1448 f:close()\
1449 end\
1450 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b8c0bc18 1451 print("Removing "..l.." from /etc/shells")\
750e19f4
ER
1452 t[l] = nil\
1453 end\
1454 s=""\
1455 for _, l in pairs(t) do\
1456 s=s..l.."\\n"\
1457 end\
1458 io.open("/etc/shells", "w"):write(s)\
1459%{-p:end} \
ad17b654
ER
1460%{nil}
1461
59d3ebe9 1462# vim:ts=4 sw=4 noet syn=spec
This page took 0.464804 seconds and 4 git commands to generate.